#include "EnergyFunctionCalculator.h"
#include <sstream>
#include "EnergyFunction.h"

using namespace CompuCell3D;
using namespace std;

EnergyFunctionCalculator::EnergyFunctionCalculator(){
   potts=0;
}

EnergyFunctionCalculator::~EnergyFunctionCalculator(){

}

void EnergyFunctionCalculator::registerEnergyFunction(EnergyFunction *_function){

  ASSERT_OR_THROW("registerEnergyFunction() function cannot be NULL!",
		  _function);

  ASSERT_OR_THROW("Potts3D Pointer  cannot be NULL!",
		  potts);

  _function->registerPotts3D(potts);

  ostringstream automaticNameStream;
  automaticNameStream<<"EnergyFuction_"<<energyFunctions.size()-1;
  string functionName;

  functionName=automaticNameStream.str();
  nameToEnergyFuctionMap.insert(make_pair(functionName,_function));

  energyFunctions.push_back(_function);
  energyFunctionsNameVec.push_back(functionName);

}

void EnergyFunctionCalculator::registerEnergyFunctionWithName(EnergyFunction *_function,std::string _functionName){

  ASSERT_OR_THROW("registerEnergyFunction() function cannot be NULL!",
        _function);

  ASSERT_OR_THROW("Potts3D Pointer  cannot be NULL!",
		  potts);

  _function->registerPotts3D(potts);
  ostringstream automaticNameStream;
  automaticNameStream<<"EnergyFuction_"<<energyFunctions.size()-1;
  string functionName;
  if(_functionName.empty()){
      functionName=automaticNameStream.str();
  }else{
      functionName=_functionName;
  }
  nameToEnergyFuctionMap.insert(make_pair(functionName,_function));

  energyFunctions.push_back(_function);
  energyFunctionsNameVec.push_back(functionName);


}


void EnergyFunctionCalculator::unregisterEnergyFunction(std::string _functionName){

  map<string,EnergyFunction*>::iterator mitr;
  mitr = nameToEnergyFuctionMap.find(_functionName);

  if(mitr==nameToEnergyFuctionMap.end()){
      cerr<<"Sorry, Could not find "<<_functionName<<" energy Function"<<endl;
      return; //plugin name not found
   }
  energyFunctions.erase(remove(energyFunctions.begin(),energyFunctions.end(),mitr->second),energyFunctions.end());
  energyFunctionsNameVec.erase(remove(energyFunctionsNameVec.begin(),energyFunctionsNameVec.end(),_functionName),energyFunctionsNameVec.end());

}

double EnergyFunctionCalculator::changeEnergy(Point3D &pt, const CellG *newCell,const CellG *oldCell,const unsigned int _flipAttempt){


  double change = 0;
  for (unsigned int i = 0; i < energyFunctions.size(); i++)
    change += energyFunctions[i]->changeEnergy(pt, newCell, oldCell);
   
  return change;

}


void EnergyFunctionCalculator::readXML(XMLPullParser &in){

}


void EnergyFunctionCalculator::writeXML(XMLSerializer &out){}

