/****************************************************************************
**
** Copyright (C) 2005-2005 Trolltech AS. All rights reserved.
**
** This file is part of the example classes of the Qt Toolkit.
**
** This file may be used under the terms of the GNU General Public
** License version 2.0 as published by the Free Software Foundation
** and appearing in the file LICENSE.GPL included in the packaging of
** this file.  Please review the following information to ensure GNU
** General Public Licensing requirements will be met:
** http://www.trolltech.com/products/qt/opensource.html
**
** If you are unsure which license is appropriate for your use, please
** review the following information:
** http://www.trolltech.com/products/qt/licensing.html or contact the
** sales department at sales@trolltech.com.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
****************************************************************************/

#include <QtGui>

#include "CellTypeColorConfigure.h"
#include "ColorItem.h"
#include <iostream>

using namespace std;

CellTypeColorConfigureForm::CellTypeColorConfigureForm(QWidget *parent)
    : QDialog(parent)
{
    ui.setupUi(this);
}

void CellTypeColorConfigureForm::loadCurrentValues(std::map<ushort,QColor> typeColorMap){
//         using namespace std;

        ui.typeColorTable->setColumnCount(2);
        ui.typeColorTable->setRowCount(typeColorMap.size());



   for(
        map<unsigned short,QColor>::iterator mitr=typeColorMap.begin()  ;
        mitr != typeColorMap.end() ;
        ++mitr
                     ){
         QTableWidgetItem *numberItem=new QTableWidgetItem(QString(QString().setNum(mitr->first) ));
         ui.typeColorTable->setItem(mitr->first,0,numberItem );
         QTableWidgetItem *item=new QTableWidgetItem;
         item->setBackgroundColor(mitr->second);
         ui.typeColorTable->setItem( mitr->first, 1, item);

        }


}



void CellTypeColorConfigureForm::on_borderColorButton_clicked(){
   QColor color=QColorDialog::getColor();
   QPalette palette;
   palette.setColor(ui.borderColorLabel->backgroundRole(), color);
   ui.borderColorLabel->setPalette(palette);

}

void CellTypeColorConfigureForm::on_contourColorButton_clicked(){
   QColor color=QColorDialog::getColor();
   QPalette palette;
   palette.setColor(ui.contourColorLabel->backgroundRole(), color);
   ui.contourColorLabel->setPalette(palette);

}



void CellTypeColorConfigureForm::on_typeColorTable_cellClicked(int row,int col){

  if(col==0)
    return;//only color cell can be changed


  QColor color=QColorDialog::getColor();





   QTableWidgetItem *item=ui.typeColorTable->item(row,col);
   item->setBackgroundColor(color);

//    cerr<<"Type="<<ui.typeColorTable->item(row,0)->text().toStdString()<<" color="<<color.name().toStdString()<<endl;
   
}


void CellTypeColorConfigureForm::on_newCellTypeButton_clicked()
{
  ui.typeColorTable->insertRow(ui.typeColorTable->rowCount());
  int col,row;
  row=ui.typeColorTable->rowCount()-1;
  col=1;

   QTableWidgetItem *item=new QTableWidgetItem;
   item->setBackgroundColor(QColor("black"));
   ui.typeColorTable->setItem( row,col, item);

//   typeColorTable->setItem(row,col,item);
}



