#ifndef SCREENSHOTDATA_H
#define SCREENSHOTDATA_H

#include "UniversalGraphicsSettings.h"
#include <string>
// #include <qstring.h>
// #include <qdir.h>
#include <QDir>
#include <fstream>

class GraphicsBase;

class ScreenshotData{

   public:
      ScreenshotData();
      ~ScreenshotData();
      UniversalGraphicsSettings univGraphSet;
      GraphicsBase *graphicsPtr;
      //QImage & getImage(){};
      void setCoreName(const std::string  & _name );
      void activate(const QString & _simulationRootDir);
      void outputScreenshot(unsigned int screenshotCounter,unsigned int numScreenNameDigits);
      void (GraphicsBase::*drawFcnPtr)(void);
      void setScreenshotIdName(const QString &);
      void setVisualizationWidgetType(const QString &);
      const QString & getVisualizationWidgetType();
      bool okToProceed(const QString & _simulationRootDir,const QString & _coreName); //will check if given directry exists


   private:
      ScreenshotData(const ScreenshotData &); /// forbid copying - avoid problems with pointer swapping etc.
      std::string coreName;
      QString fullInventoryFileName;
      QString thisDirectoryName;
      QString simulationRootDir;
      QString visualizationWidgetType;
      QDir dir;
      std::ofstream *inventoryFilePtr;
      QString screenshotIdName;
      
};



#endif
