/*
GRN model
Copyright (C) 2005-2008  Johannes Knabe
j.f.knabe@herts.ac.uk

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/
#pragma once

#include <iostream>
#include <sstream>
#include <cmath>
#include <string>
#include <stdexcept>
#include <vector>
#include "KnabeGene.h"
using namespace std;

vector<std::string> split(std::string& what, std::string delim);
unsigned short int fromBinary(vector<unsigned short int> bin);
vector<unsigned short int> toBinary(unsigned short int bin);
std::string intArrToString(vector<unsigned short int> in);
vector<unsigned short int> stringToIntArr(std::string in);

class KnabeGRN

{public:
 int howLong; //lifetime counter
 int currentGeneNo;    //number of genes
 double fitness;
 double bindingProportion;
 double saturationValue;
 vector<unsigned short int> cisSitesReceptiveFor; //number of cis-sites that match a protein (sum over all genes and cis-sites)
 vector<unsigned short int> genome;
 vector<KnabeGene*> genes;
 vector<unsigned short int> geneOutputProtein;
 vector<unsigned short int> geneOutputActivity;
 vector<double> concentrations;
 vector<double> proteinDecay;

public:
	KnabeGRN(std::string geno);
public:
	~KnabeGRN(void);
public:
	double process(double in, double in2, double in3);
public:
	double process(double in);

	void applySaturationCheck();
};
