#ifndef COMPUCELL3DREACTIONDIFFUSIONFILE_H
#define COMPUCELL3DREACTIONDIFFUSIONFILE_H


#include <CompuCell3D/Steppable.h>
#include <CompuCell3D/Potts3D/Cell.h>
#include "DiffusableVector.h"

#include <string>
#include <vector>
#include <algorithm>
#include <iostream>
typedef unsigned short uint16_t; /* This is 32-bits, should be 16 !!! */
typedef unsigned short uint32_t;

namespace CompuCell3D {

/**
@author m
*/
//forward declarations
class Potts3D;
class Simulator;
class Cell;
class CellInventory;
class Automaton;

template <typename Y> class Field3D;
template <typename Y> class Field3DImpl;

class ReactionDiffusionFile :public DiffusableVector<float>
{
protected:
   Simulator *simPtr;
   
   std::string fileName;  
   unsigned int currentStep;
   unsigned int numberOfFields;
   Dim3D fieldDim;

   
public:
    ReactionDiffusionFile();

    virtual ~ReactionDiffusionFile();
   
    virtual void init(Simulator *simulator);

    // Begin Steppable interface
    virtual void start();
    virtual void step(const unsigned int _currentStep);
    virtual void finish() {}
    // End Steppable interface

    // Begin XMLSerializable interface
    virtual void readXML(XMLPullParser &in);
    virtual void writeXML(XMLSerializer &out){};
    // End XMLSerializable interface
    bool isLittleEndian() {
       unsigned int tmp=1;
       return (0 != *(reinterpret_cast<const char*>(&tmp)));
    }   

   template <typename T> inline
   void swapBytes(T& t) {
      char* res = reinterpret_cast<char*>(&t);
      std::reverse(res, res+sizeof(T));
   }
};

};

#endif
