#ifndef NUMERICALUTILS_H
#define NUMERICALUTILS_H

#include <Utils/Coordinates3D.h>
#include <CompuCell3D/Potts3D/Cell.h>
#include <CompuCell3D/Field3D/Point3D.h>


float findMin( float _d , int _dim );

double dist(double x0,double y0,double z0);
double dist(double x0,double y0,double z0,double x1,double y1,double z1);

namespace CompuCell3D{


class CellG;
class Point3D;



Coordinates3D<int> precalculateCentroid(const Point3D & pt, const CellG *_cell, int _volumeIncrement,const Point3D & _fieldDim);

double distInvariantCM(double x0,double y0,double z0,double x1,double y1,double z1,const Point3D & _fieldDim);

Point3D distanceVectorInvariant(const Point3D & _pt1 ,const Point3D & _pt0,const Point3D & _fieldDim);


typedef std::pair<Coordinates3D<float>, Coordinates3D<float> > CenterOfMassPair_t;
CenterOfMassPair_t precalculateAfterFlipCM(const Point3D &pt, const CellG *newCell, const CellG *oldCell,const Point3D & fieldDim, const Point3D & boundaryConditionIndicator);


};
#endif
