/*************************************************************************
 *    CompuCell - A software framework for multimodel simulations of     *
 * biocomplexity problems Copyright (C) 2003 University of Notre Dame,   *
 *                             Indiana                                   *
 *                                                                       *
 * This program is free software; IF YOU AGREE TO CITE USE OF CompuCell  *
 *  IN ALL RELATED RESEARCH PUBLICATIONS according to the terms of the   *
 *  CompuCell GNU General Public License RIDER you can redistribute it   *
 * and/or modify it under the terms of the GNU General Public License as *
 *  published by the Free Software Foundation; either version 2 of the   *
 *         License, or (at your option) any later version.               *
 *                                                                       *
 * This program is distributed in the hope that it will be useful, but   *
 *      WITHOUT ANY WARRANTY; without even the implied warranty of       *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU    *
 *             General Public License for more details.                  *
 *                                                                       *
 *  You should have received a copy of the GNU General Public License    *
 *     along with this program; if not, write to the Free Software       *
 *      Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.        *
 *************************************************************************/

#ifndef CONTACTMULTICADPLUGIN_H
#define CONTACTMULTICADPLUGIN_H



#include "ContactMultiCadEnergy.h"
#include "ContactMultiCadData.h"



#include <BasicUtils/BasicClassAccessor.h>
#include <BasicUtils/BasicClassGroup.h> //had to include it to avoid problems with template instantiation

#include <CompuCell3D/Potts3D/CellGChangeWatcher.h>
#include <CompuCell3D/Plugin.h>

namespace CompuCell3D {
  class ContactMultiCadEnergy;
  class Simulator;


  class ContactMultiCadPlugin : public Plugin {


   private:
    ContactMultiCadEnergy *contactEnergy;
    BasicClassAccessor<ContactMultiCadData> contactMultiCadDataAccessor;
    Potts3D *potts;
    Simulator *sim;


  public:

    BasicClassAccessor<ContactMultiCadData> * getContactMultiCadDataAccessorPtr(){return & contactMultiCadDataAccessor;}
    
    
    

  public:
   
    ContactMultiCadPlugin();
    virtual ~ContactMultiCadPlugin();
    

    virtual void init(Simulator *simulator);

    // Begin XMLSerializable interface
    virtual void readXML(XMLPullParser &in);
    virtual void writeXML(XMLSerializer &out);
    // End XMLSerializable interface
  };
};
#endif
