#pragma once

#include <iostream>
#include <sstream>
#include <cmath>
#include <string>
#include <stdexcept>
#include <vector>
#define isnan(x) ((x) != (x))
using namespace std;

class KnabeGene
{public:
 int numberOfCisSites;
 unsigned short int geneOutputProtein;
 unsigned short int geneOutputActivity;
 void *holder;//of type KnabeGRN

 vector<unsigned short int> data;
 vector<vector<unsigned short int> > geneCisReceptorSites;//first array: number of sites
                                    //2nd array:   value one activ/inhib,
                                    //             value two and plus ProteinSites (in Quick implementation always exactly one, but later several ones for AND combos)
 vector<vector<double> > * proteinSiteActivations;//first array: number of sites
                                      //2nd array:   for every protein binder the activation (in Quick implementation always exactly one binder per site but later several proteins bind per site [AND combination])

 vector<vector<double> > PSAinit;

public:
	KnabeGene(std::string bases, void *holder);
	~KnabeGene(void);
	double getOutputForProtein(int which);
	void bindingProtein(int which, double strength);
	vector<unsigned short int>* getCisSite(int numbero);
	int getNoOfCisSitesForProt(int which);
};
